//CharSelector.js

//Contains Character Selector stuff.

//Arrays can contain more data than a single variable. It's more useful for listing stuff.
//This array will contain the menu options. They will be the character names.
var SelectableSprites = new Array("Bally", "GreenBally", "BlueBally");

//An array for the images. And spritesets. They are in the sanme order as the above array
//(so "ball" matches "Bally").
var SpritesImages = new Array("ball", "ball2", "ball3");

var Selected = 0;		//A variable for our selected option.



function SelectChar()
{
	//Since there's no RenderMap() in here, things will be drawn on a black screen.
	//You can add one if you want, and if the map engine is running when opening this menu.

	var font = GetSystemFont();

	//Change values if neccesary.
	var windowstyle = GetSystemWindowStyle();
	var x = 16;
	var y = 16;
	var width = 100;
	var height = font.getHeight();
	
	var WindowHeight = height * SelectableSprites.length + y;
	//SelectableSprites.length checks the length of our array SelectableSprites,
	//which is 3 because we entered 3 things in it.
	
	windowstyle.drawWindow(x, y, width, WindowHeight);
	
	//A loop for drawing our array names.
	for (var i = 0; i < SelectableSprites.length; i++)
	{
		//Draw a textbox at y position 16 * current looked at option + y.
		//The text shown will be the current array entry in SelectableSprites.
		font.drawTextBox(x, i*16+y, 100, 16, 0, SelectableSprites[i]);
	}
	
	//Draw the right image, based on the var Selected (which looks at the currently selected option).
	var CharImage = LoadImage(SpritesImages[Selected] + ".png");
	CharImage.blit(150, y*2);
	
	//Draw a box around our selected option.
	var BoxImage= LoadImage("BoxImage.png");
	
	//This may look complicated, but it's not. Blit at x 16-2 and y (the height of y * Selected option) + (16 - 2).
	BoxImage.blit(x-2, (y*Selected)+(y-2));
	
	//Draw our final stuff.
	FlipScreen();
	
	//Now we're gonna start a new function, to keep this one a bit clear. The CM is short for CharMenu. :P
	LookKeyPressesCM();
}
	


function LookKeyPressesCM()
{
	//First, let's ask for user key input.
	GetKey();
	
	//Now, let's do stuff with it!
	
	//If up-key is pressed while the selected option isn't the top one...
	if (IsKeyPressed(KEY_UP) && Selected > 0)
	{
		//Selected-- means that we are substracting 1 from our var Selected. So the value of Selected becomes 1 less.
		//Since we're using Selected for our selected option in the menu, this means we go up one option.
		Selected--;
		
		//Now go back to re-rendering the menu.
		SelectChar();
	}
	
	//If a key was pressed, but it wasn't key up but key down...
	// + if our selected option isn't the lowest one (which practically means our array length)...
	else if (IsKeyPressed(KEY_DOWN) && Selected < SelectableSprites.length-1)
	{
		//variable++ is almost like variable--, except that it ADDs 1 to the variable.
		Selected++;
		SelectChar();
	}
	
	else if (IsKeyPressed(KEY_SPACE))
	{
		//Create a new person with the name MainPerson and with the spriteset (name in SpritesImages).rss.
		CreatePerson("MainPerson", SpritesImages[Selected] + ".rss", false);
		
		//And give the person his movement and camera view.
		AttachInput("MainPerson");
		AttachCamera("MainPerson");

		//Let's not go back to the menu. So we don't type SelectChar.
		//This basically means that the loop of rendering the menu is exited. So we can continue the game.
	}
	
	//If ANY other key was pressed...
	else
	{
		//Render the menu again without changing anything.
		SelectChar();
	}

//Exit our little function ^_^
}

