/*
====================
		EXAMPLE SCRIPT 2: MAKING A PERSON SELECTOR AND MENUS
		Vincent Beers, 2005
		http://DaVince.websitemaster.org/
		http://DaVince.sitesled.com/
		Email: VincentBeers@yahoo.com
		
		This tutorial shows you how to make a person selector and play with that person.
		Also, the text box is more advanced so it ONLY RESPONDS TO THE SPACE BAR.
		
		For tutorial 1 and other tutorials, go to one of my websites.
*/


//The sprite selector stuff is in another script, CharSelector.js.
//So we'll have to tell Sphere that a new script is used.
//	RequireScript("script");
RequireScript("CharSelector.js");


//Start function.
function game()
{
//Our new function which will make a new menu appear with the available persons.
SelectChar();

//Our CreatePersons() and AttachCameras() are moved to the SelectChar function.

var Music = LoadSound("OpenPod.mid");
Music.play(true);

MapEngine("ExampleMap.rmp", 60);
}


//========================
//		IMPROVED TEXTBOX (space bar)
//========================

function TextBox(text)
{
	//While the space key IS pressed, wait until it's released.
  while (IsKeyPressed(KEY_SPACE));
  
  //This stuff's still the same.
  var font = GetSystemFont();
  
  var windowstyle = GetSystemWindowStyle();
  var x = 16;
  var y = 16;
  var width = GetScreenWidth() - 32;
  var height = font.getStringHeight(text, width);
  
  if (IsMapEngineRunning() == true)
  {
	RenderMap();
  }
  
  windowstyle.drawWindow(x, y, width, height);
  font.drawTextBox(x, y, width, height, 0, text);
  FlipScreen();
  

  //MODIFIED CODE!
  //You'll now have to press space before being able to continue.
  //While key space is not pressed, no nothing and wait until it is.
  while (!IsKeyPressed(KEY_SPACE));
  
  //SECURITY: to make sure that you can't go through textboxes too quickly, here's a
  //small security loop to wait until you released the space key again.
  //While the space key IS pressed, wait until it's released.
  while (IsKeyPressed(KEY_SPACE));
}



//The same as always.
function Warp(map, x, y)
{
FadeOut(3);

ChangeMap(map);
SetPersonX("MainPerson", x * 16 + 5);
SetPersonY("MainPerson", y * 16 + 5);
//The + 5 is to set the position a bit more correctly. Remove it to see what I mean! ;)

FadeIn(3);
}



function FadeOut(speed)
{
var i = 0;
var FadeColor;

var SW = GetScreenWidth();
var SH = GetScreenHeight();

var ScreenImage = GrabImage(0,0, SW, SH);

if (IsMapEngineRunning())
{
	RenderMap();
}

for (i = 0; i < 255; i+=speed)
{
	
	if (IsMapEngineRunning())
	{
		RenderMap();
	}

	FadeColor = CreateColor(0, 0, 0, i);
	
	ScreenImage.blitMask(0,0, FadeColor);
	FlipScreen();
}
}


function FadeIn(speed, R, G, B)
{
var i = 255;
var FadeColor;
var SW = GetScreenWidth();
var SH = GetScreenHeight();

var Surface = GrabSurface(0,0,GetScreenWidth(),GetScreenHeight());
var SurfaceImage = Surface.createImage();

for (i = 255; i > 0; i-=speed)
{
	if (IsMapEngineRunning())
	{
		RenderMap();
	}

	FadeColor = CreateColor(0, 0, 0, i);
	SurfaceImage.blitMask(0,0, FadeColor);
	FlipScreen();
}
}


function Delay(milliseconds)
{
  var start = GetTime();
  while (start + milliseconds > GetTime())
  {
  }
}
